// Oɂ͌JȂutiln̊֐Q
#include <ctype.h>
#include <string.h>
#include "bmsfel_p.h"

namespace BmsUtil {

  static const char HEX36_TABLE[HEX36_MAX] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

  //////////////////////////////////////////////////
  // int36i̕ɕϊ(input : 0`35)
  char int_to_hex36( int x ) {
    return HEX36_TABLE[x % HEX36_MAX];
  }

  //////////////////////////////////////////////////
  // 36i̕intɕϊ
  int hex36_to_int( char *str ) {
    return hex36_to_int( *(str), *(str + 1) );
  }

  int hex36_to_int( char msb, char lsb ) {
    int temp = 0;

    if ( isalnum( msb ) == false ) { msb = '0'; }
    msb = (char)toupper( msb );
    if ( isalnum( lsb ) == false ) { lsb = '0'; }
    lsb = (char)toupper( lsb );

    for ( int i = 0; i < HEX36_MAX; ++i ) {
      if ( HEX36_TABLE[i] == msb ) { temp += i * HEX36_MAX; }
      if ( HEX36_TABLE[i] == lsb ) { temp += i; }
    }
    return temp;
  }

  //////////////////////////////////////////////////
  // ő񐔂߂
  int gcd( int x, int y ) {
    if( x == 0 || y == 0 ) { return 0; }
    while ( x != y ) {
      if ( x > y ) { x -= y; }
      else         { y -= x; }
    }
    return x;
  }

  //////////////////////////////////////////////////
  // 啶
  void str2upper( char *str ) {
    for ( int i = 0; str[i] != '\0'; ++i ) {
      str[i] = (char)toupper( str[i] );
    }
  }

  //////////////////////////////////////////////////
  // Rs[ė̈m
  char *str_new_cpy( const char *str, bool to_upper_flag ) {
    if ( str == NULL ) { return NULL; }
    char *temp = new char[strlen( str ) + 1];
    strcpy( temp, str );
    if ( to_upper_flag ) { BmsUtil::str2upper( temp ); }
    return temp;
  }

}
