#include "bmsfel_p.h"

//################################################
// `ln

// `l邩
int BmsBms::get_channel_count() const {
  return this->channel_count;
}

//////////////////////////////////////////////////
// getn

// Xgŏ̃`lԂ
BmsChannel *BmsBms::get_first_channel() const {
  return this->first_channel;
}

// `lio[Ɉv`lIuWFNgԂ
BmsChannel *BmsBms::get_channel( BmsWord channel_word ) const {
  EACH_KIND_CHANNEL( this->first_channel, temp_channel ) {
    if ( temp_channel->get_channel_number() == channel_word ) {
      return temp_channel;
    }
  }
  return NULL_CHANNEL;
}


//////////////////////////////////////////////////
// setn
// `lIuWFۑB
// ɓ`lio[̃IuWFNgꍇ
// ̓IuWFƓւāA߂lƂĂԂ
// Ԃ`lIuWFNgdelete͌Ăяo
BmsChannel *BmsBms::set_channel( BmsChannel *input_channel ) {
  if ( input_channel == NULL_CHANNEL ) { return NULL_CHANNEL; }

  BmsChannel *prev_channel = NULL_CHANNEL;
  BmsChannel *temp_channel = NULL_CHANNEL;
  BmsChannel *next_channel = NULL_CHANNEL;

  for ( temp_channel = this->first_channel;
        temp_channel != NULL_CHANNEL;
        temp_channel = temp_channel->get_next() ) {

    int temp_sub = temp_channel->get_channel_number().compare( input_channel->get_channel_number() );
    if ( temp_sub == 0 ) {
      next_channel = temp_channel->get_next();
      break;
    }
    else if ( temp_sub > 0 ) {
      next_channel = temp_channel;
      temp_channel = NULL_CHANNEL;
      break;
    }
    else {
      prev_channel = temp_channel;
    }
  }
  this->insert_list_channel( prev_channel, next_channel, input_channel );
  if ( temp_channel == NULL_CHANNEL ) { ++this->channel_count; }
  return temp_channel;
}

// set_channelœ`lꍇ㏑āAȑÔdelete
// set_channelƓ ߂l͈ȑÔǂ
bool BmsBms::overwrite_channel( BmsChannel *input_channel ) {
  bool return_value = false;
  BmsChannel *temp_channel = this->set_channel( input_channel );
  if ( temp_channel != NULL_CHANNEL ) {
    delete temp_channel;
    return_value = true;
  }
  return return_value;
}


// perv->next  input ɂinput->next  current ɂ
// prev == NULL_CHANNEL ̏ꍇfirst_channel  input 
void BmsBms::insert_list_channel( BmsChannel *prev, BmsChannel *next, BmsChannel *input ) {
  if ( prev == NULL_CHANNEL ) { this->first_channel = input; }
  else { prev->set_next( input ); }
  input->set_next( next );
}

//////////////////////////////////////////////////
// deleten
// oČĂяoɕԂ delete͌Ăяo
BmsChannel *BmsBms::take_channel( BmsWord channel_word ) {
  BmsChannel *prev_channel = NULL_CHANNEL;
  BmsChannel *temp_channel = NULL_CHANNEL;
  BmsChannel *next_channel = NULL_CHANNEL;

  for ( temp_channel = this->first_channel;
        temp_channel != NULL_CHANNEL;
        temp_channel = temp_channel->get_next() ) {

    int temp_sub = temp_channel->get_channel_number().compare( channel_word );
    if ( temp_sub == 0 ) {
      next_channel = temp_channel->get_next();
      break;
    }
    else if ( temp_sub > 0 ) {
      temp_channel = NULL_CHANNEL;
      break;
    }
    else {
      prev_channel = temp_channel;
    }
  }
  this->take_list_channel( prev_channel, next_channel, temp_channel );
  if ( temp_channel != NULL_CHANNEL ) { --this->channel_count; }
  return temp_channel;
}

// deletes
bool BmsBms::delete_channel( BmsWord channel_word ) {
  bool return_value = false;
  BmsChannel *temp = this->take_channel( channel_word );
  if ( temp != NULL_CHANNEL ) {
    delete temp;
    return_value = true;
  }
  return return_value;
}

// perv->next  next ɂtake->next  NULL_CHANNEL ɂ
// prev == NULL_CHANNEL ̏ꍇfirst_channel  next 
// take == NULL_CHANNEL ̏ꍇ͉Ȃ ߂ltakeƓ
BmsChannel *BmsBms::take_list_channel( BmsChannel *prev, BmsChannel *next, BmsChannel *take ) {
  if ( take == NULL_CHANNEL ) { return take; }

  if ( prev == NULL_CHANNEL ) { this->first_channel = next; }
  else { prev->set_next( next ); }
  take->set_next( NULL_CHANNEL );
  return take;
}

//////////////////////////////////////////////////
// gɂ ߂l͏
int BmsBms::clear_channel() { 
  int deleted_num = 0;
  BmsChannel *next;
  for ( BmsChannel *temp = this->first_channel; temp != NULL_CHANNEL; temp = next ) {
    next = temp->get_next();
    delete temp;
    ++deleted_num;
  }
  this->first_channel = NULL_CHANNEL;
  this->channel_count = 0;
  return deleted_num;
}
