#include <string.h>
#include "bmsfel_p.h"

//################################################
// BMS̗vf̑SĂǗNX BMSt@C̒ۉ

//////////////////////////////////////////////////
// RXgN^Q
BmsBms::BmsBms() {
  this->headers = new BmsHeaderHash();
  this->wavs = new BmsRegistArray( "WAV" );
  this->bmps = new BmsRegistArray( "BMP" );
  this->channel_count = 0;
  this->first_channel = NULL_CHANNEL;
}

// fXgN^
BmsBms::~BmsBms() {
  delete this->headers;
  delete this->wavs;
  delete this->bmps;
  this->clear_channel();
}

//////////////////////////////////////////////////
// getn delete͈ڂȂ
BmsHeaderHash *BmsBms::get_headers() const {
  return this->headers;
}

BmsRegistArray *BmsBms::get_wavs() const {
  return this->wavs;
}

BmsRegistArray *BmsBms::get_bmps() const {
  return this->bmps;
}


//////////////////////////////////////////////////
// ȍ~̓[eBeBn

// nthߖڂchannel_word̃`lɑ΂đ삷
// channel_word̃`l܂ꍇ
// Rs[Ď擾 delete͌Ăяo
BmsBuffer *BmsBms::pop_out( int nth, BmsWord channel_word ) {
  BmsChannel *current_channel = this->get_channel( channel_word );
  if ( current_channel == NULL_CHANNEL ) {
    return new BmsBuffer( this->bar_at( nth ).get_length_int() );
  }

  return current_channel->slice_length(
    this->get_channel_position( nth ),
    this->bar_at( nth ).get_length_int() );
}

// ͂ď㏑ delete̓Rei
int BmsBms::push_in( int nth, BmsWord channel_word, BmsBuffer *input_buffer ) {
  BmsChannel *current_channel = this->get_channel( channel_word );
  if ( current_channel == NULL_CHANNEL ) {
    current_channel = new BmsChannel( channel_word );
    this->set_channel( current_channel );
  }

  return current_channel->push_in(
    this->get_channel_position( nth ),
    input_buffer );
}

// nth߂channel_word`lstr 
int BmsBms::input_str( int nth, BmsWord channel_word, char *str ) {
  return this->input_n_str( nth, channel_word, strlen( str ), str );
}

// n = ̒
int BmsBms::input_n_str( int nth, BmsWord channel_word, int n, char *str ) {
  int to = this->get_channel_position( nth );
  int length = this->bar_at( nth ).get_length_int();

  if ( n == 0 || ( n % 2 ) == 1 || ( n / 2 ) > length ) { return 0; }

  BmsChannel *current_channel = this->get_channel( channel_word );
  if ( current_channel == NULL_CHANNEL ) {
    current_channel = new BmsChannel( channel_word );
    this->set_channel( current_channel );
  }
  
  int str_position = 0;
  int step = length / ( n / 2 );
  for ( int i = to; i < to + length; i += step ) {
    current_channel->overwrite( i, BmsObject( &str[str_position] ) );
    str_position += 2;
  }
  return str_position;
}

// nth߂channel_word`l𕶎o
// IuWF𕶎ɕϊ ߂l͎ۂɕϊ̑傫
// |C^̐ length * 2 傫ȗ̈pӂ邱
int BmsBms::to_str( int nth, BmsWord channel_word, char *str ) const {
  BmsChannel *current_channel = this->get_channel( channel_word );
  if ( current_channel == NULL_CHANNEL ) {
    return -1;
  }

  int to = this->get_channel_position( nth );
  int length = this->bar_at( nth ).get_length_int();

  // ΂ԊuvZ
  int step = length;
  for ( int i = 1; i < length; ++i ) {
    if ( current_channel->at( to + i ) != "00" ) {
      step = BmsUtil::gcd( step, i );
    }
  }
  
  int str_position = 0;
  for ( int i = to; i < to + length; i += step ) {
    current_channel->at( i ).get_str( &str[str_position] );
    str_position += 2;
  }

  return str_position;
}
// Ō'\0't length * 2 + 1 傫ȗ̈pӂ邱
// ߂l͓̗͂̈ւ̃|C^
int BmsBms::to_str_null( int nth, BmsWord channel_word, char *str ) const {
  int temp = this->to_str( nth, channel_word, str );
  if ( temp != -1 ) { str[temp] = '\0'; }
  return temp;
}
